#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <arpa/inet.h>

#define MOVE_FOWARD '1'
#define MOVE_BACK   '2'
#define TURN_LEFT   '3'
#define TURN_RIGHT  '4'
#define TEST        '5'
#define STOP        '0'

int main(int argc, char **argv){
    int fd,n; 
	unsigned char command;

	fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NDELAY);

	if (fd == -1){
		perror("open port : Unable to open ttyS0");
		return (-1);
	}

	struct termios options;
	tcgetattr(fd,&options);
	options.c_cflag = B9600 | CS8 | CLOCAL | CREAD;
	options.c_iflag = IGNPAR;
	options.c_oflag = 0;
	options.c_lflag = 0;
	tcflush(fd,TCIFLUSH);
	tcsetattr(fd,TCSANOW,&options);

	fcntl(fd, F_SETFL , 0);

    int tmp,angle;
    char data[5] = {0xEF, 0xFE}; 
    while(1){
        printf("input num: ");
        scanf("%d",data +2);
        if(0 == data[2]){
            break;
        }
        printf("input angle: ");
        scanf("%d",&angle);
        tmp = (double)angle / 180.0 * 2000 + 500;
        data[4] = tmp;
        data[3] = tmp >> 8;
        n = write(fd, data,5);
        n = write(fd, data,5);
	    if (n < 0){
		    perror("Write failed -");
		    return -1;
	    }
        printf("\n");
    }
	
	close(fd);
	return 0;
}

