#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <arpa/inet.h>

#define MOVE_FOWARD '1'
#define MOVE_BACK   '2'
#define TURN_LEFT   '3'
#define TURN_RIGHT  '4'
#define TEST        '5'
#define STOP        '0'

char rst[180] = {
 0xEF,0xFE,0x01,0x05,0xDC,0xEF,0xFE,0x01,0x05,0xDC
,0xEF,0xFE,0x02,0x05,0xDC,0xEF,0xFE,0x02,0x05,0xDC
,0xEF,0xFE,0x03,0x05,0xDC,0xEF,0xFE,0x03,0x05,0xDC
,0xEF,0xFE,0x04,0x05,0xDC,0xEF,0xFE,0x04,0x05,0xDC
,0xEF,0xFE,0x05,0x05,0xDC,0xEF,0xFE,0x05,0x05,0xDC
,0xEF,0xFE,0x06,0x05,0xDC,0xEF,0xFE,0x06,0x05,0xDC
,0xEF,0xFE,0x07,0x05,0xDC,0xEF,0xFE,0x07,0x05,0xDC
,0xEF,0xFE,0x08,0x05,0xDC,0xEF,0xFE,0x08,0x05,0xDC
,0xEF,0xFE,0x09,0x05,0xDC,0xEF,0xFE,0x09,0x05,0xDC
,0xEF,0xFE,0x0A,0x05,0xDC,0xEF,0xFE,0x0A,0x05,0xDC
,0xEF,0xFE,0x0B,0x05,0xDC,0xEF,0xFE,0x0B,0x05,0xDC
,0xEF,0xFE,0x0C,0x05,0xDC,0xEF,0xFE,0x0C,0x05,0xDC
,0xEF,0xFE,0x0D,0x05,0xDC,0xEF,0xFE,0x0D,0x05,0xDC
,0xEF,0xFE,0x0E,0x05,0xDC,0xEF,0xFE,0x0E,0x05,0xDC
,0xEF,0xFE,0x0F,0x05,0xDC,0xEF,0xFE,0x0F,0x05,0xDC
,0xEF,0xFE,0x10,0x05,0xDC,0xEF,0xFE,0x10,0x05,0xDC
,0xEF,0xFE,0x11,0x05,0xDC,0xEF,0xFE,0x11,0x05,0xDC
,0xEF,0xFE,0x12,0x05,0xDC,0xEF,0xFE,0x12,0x05,0xDC
};

int main(int argc, char **argv){
    int fd,n; 
	unsigned char command;

	fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NDELAY);

	if (fd == -1){
		perror("open port : Unable to open ttyS0");
		return (-1);
	}

	struct termios options;
	tcgetattr(fd,&options);
	options.c_cflag = B9600 | CS8 | CLOCAL | CREAD;
	options.c_iflag = IGNPAR;
	options.c_oflag = 0;
	options.c_lflag = 0;
	tcflush(fd,TCIFLUSH);
	tcsetattr(fd,TCSANOW,&options);

	fcntl(fd, F_SETFL , 0);
    
    n = write(fd, rst,180);
	if (n < 0){
		perror("Write failed -");
		return -1;
	}

	
	close(fd);
	return 0;
}
