#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <termios.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdlib.h>
#include <arpa/inet.h>

#define MOVE_FOWARD '1'
#define MOVE_BACK   '2'
#define TURN_LEFT   '3'
#define TURN_RIGHT  '4'
#define TEST        '5'
#define STOP        '0'

char rst[180] = {
 0xEF,0xFE,0x01,0x05,0xDC,0xEF,0xFE,0x01,0x05,0xDC
,0xEF,0xFE,0x02,0x05,0xDC,0xEF,0xFE,0x02,0x05,0xDC
,0xEF,0xFE,0x03,0x05,0xDC,0xEF,0xFE,0x03,0x05,0xDC
,0xEF,0xFE,0x04,0x05,0xDC,0xEF,0xFE,0x04,0x05,0xDC
,0xEF,0xFE,0x05,0x05,0xDC,0xEF,0xFE,0x05,0x05,0xDC
,0xEF,0xFE,0x06,0x05,0xDC,0xEF,0xFE,0x06,0x05,0xDC
,0xEF,0xFE,0x07,0x05,0xDC,0xEF,0xFE,0x07,0x05,0xDC
,0xEF,0xFE,0x08,0x05,0xDC,0xEF,0xFE,0x08,0x05,0xDC
,0xEF,0xFE,0x09,0x05,0xDC,0xEF,0xFE,0x09,0x05,0xDC
,0xEF,0xFE,0x0A,0x05,0xDC,0xEF,0xFE,0x0A,0x05,0xDC
,0xEF,0xFE,0x0B,0x05,0xDC,0xEF,0xFE,0x0B,0x05,0xDC
,0xEF,0xFE,0x0C,0x05,0xDC,0xEF,0xFE,0x0C,0x05,0xDC
,0xEF,0xFE,0x0D,0x05,0xDC,0xEF,0xFE,0x0D,0x05,0xDC
,0xEF,0xFE,0x0E,0x05,0xDC,0xEF,0xFE,0x0E,0x05,0xDC
,0xEF,0xFE,0x0F,0x05,0xDC,0xEF,0xFE,0x0F,0x05,0xDC
,0xEF,0xFE,0x10,0x05,0xDC,0xEF,0xFE,0x10,0x05,0xDC
,0xEF,0xFE,0x11,0x05,0xDC,0xEF,0xFE,0x11,0x05,0xDC
,0xEF,0xFE,0x12,0x05,0xDC,0xEF,0xFE,0x12,0x05,0xDC
};

char taishou[14] = {
     1,45,
     3,105,
    10,120,

     2,20,
    11,20,
     9,35,
    18,45,

};

char zuoyi1[4] = {  
     3,45,
    12,45,
};

char zuoyi2[4] = {
    3,90,
    12,90
};

int main(int argc, char **argv){
    int fd,n; 
	unsigned char command;

	fd = open("/dev/ttyS0", O_RDWR | O_NOCTTY | O_NDELAY);

	if (fd == -1){
		perror("open port : Unable to open ttyS0");
		return (-1);
	}

	struct termios options;
	tcgetattr(fd,&options);
	options.c_cflag = B9600 | CS8 | CLOCAL | CREAD;
	options.c_iflag = IGNPAR;
	options.c_oflag = 0;
	options.c_lflag = 0;
	tcflush(fd,TCIFLUSH);
	tcsetattr(fd,TCSANOW,&options);

	fcntl(fd, F_SETFL , 0);

    n = write(fd, rst,sizeof(rst));
	if (n < 0){
		perror("Write failed -");
		return -1;
	}

    int tmp,angle;
    char data[5] = {0xEF, 0xFE}; 
    for(int i = 0;i < sizeof(taishou);i += 2){
        data[2] = taishou[i];
        angle = taishou[i + 1];
        tmp = (double)angle / 180.0 * 2000 + 500;
        data[4] = tmp;
        data[3] = tmp >> 8;
        n = write(fd, data,5);
        n = write(fd, data,5);
	    if (n < 0){
		    perror("Write failed -");
		    return -1;
	    }
    }
	sleep(2);

    for(int i = 0;i < 3;++i){
        data[2] = zuoyi1[0];
        angle =zuoyi1[1];
        tmp = (double)angle / 180.0 * 2000 + 500;
        data[4] = tmp;
        data[3] = tmp >> 8;
        n = write(fd, data,5);
        n = write(fd, data,5);
	    if (n < 0){
		    perror("Write failed -");
		    return -1;
	    }
        data[2] = zuoyi1[2];
        angle =zuoyi1[3];
        tmp = (double)angle / 180.0 * 2000 + 500;
        data[4] = tmp;
        data[3] = tmp >> 8;
        n = write(fd, data,5);
        n = write(fd, data,5);
	    if (n < 0){
		    perror("Write failed -");
		    return -1;
	    }
        sleep(1);
        data[2] = zuoyi2[0];
        angle =zuoyi2[1];
        tmp = (double)angle / 180.0 * 2000 + 500;
        data[4] = tmp;
        data[3] = tmp >> 8;
        n = write(fd, data,5);
        n = write(fd, data,5);
	    if (n < 0){
		    perror("Write failed -");
		    return -1;
	    }
        data[2] = zuoyi2[2];
        angle =zuoyi2[3];
        tmp = (double)angle / 180.0 * 2000 + 500;
        data[4] = tmp;
        data[3] = tmp >> 8;
        n = write(fd, data,5);
        n = write(fd, data,5);
	    if (n < 0){
		    perror("Write failed -");
		    return -1;
	    }
		sleep(1);
    }

    n = write(fd, rst,sizeof(rst));
	if (n < 0){
		perror("Write failed -");
		return -1;
	}
	
	close(fd);
	return 0;
}
