module spider #
(
parameter				UART_BAUD = 1250   // 1250 for 9600 baud rate when 12MHz clk_in

//parameter               CHANNEL   = 1       // PWM total 
)
(
input					clk_in,				// 12MHz system clock
input					rst_n_in,			// system reset, active low

input					rs232_rx,			// uart receive pin
output					rs232_tx,			// uart transfer pin

output                  PWM_out1,
output                  PWM_out2,
output                  PWM_out3,
output                  PWM_out4,
output                  PWM_out5,
output                  PWM_out6,
output                  PWM_out7,
output                  PWM_out8,
output                  PWM_out9,
output                  PWM_out10,
output                  PWM_out11,
output                  PWM_out12,
output                  PWM_out13,
output                  PWM_out14,
output                  PWM_out15,
output                  PWM_out16,
output                  PWM_out17,
output                  PWM_out18
);

/*
// reset
reg                    rst_num = 2'b0;
always @ (posedge clk_in)
*/

localparam      IDLE    = 3'd0;
localparam      STAT1   = 3'd1;
localparam      STAT2   = 3'd2;
localparam      ID      = 3'd3;
localparam      DATA1   = 3'd4;
localparam      DATA2   = 3'd5;
//localparam      END     = 3'd5;

reg             [2:0]   state = IDLE;       //״̬ʼ״̬

//reg        [3:0]   data_num = 4'b0;     

reg             [7:0]	pwm_num = 8'b0; 
reg            [23:0]   PWM_width = 24'b0;
reg                     rx_over = 1'b0;

wire                    rx_data_valid;  // գЧ־ߵƽһʱ
wire			[7:0]	rx_data_out;    // ڽյ

reg  					tx_data_valid;		// tx_data_in valid when tx_data_valid active
reg 			[7:0]	tx_data_in;			// data need to transfer
wire                    tx_busy;            // uart tx busy
// Э
always @ (posedge clk_in) begin
	if(!rst_n_in) begin          // λ״̬
		PWM_width <= 24'b0;
		pwm_num <= 8'b0;
		state <= IDLE;
	end	else begin
		case(state)
			IDLE  : begin        // ָ״̬
				rx_over <= 1'b0;
				state <= STAT1;
			end
			STAT1 : begin        // յЭͷ EF
				if(rx_data_valid) begin
					if(rx_data_out == 8'hEF) begin
						PWM_width <= 24'b0;
						pwm_num <= 8'b0;
						state <= STAT2;
					end 
				end
			end
			STAT2 : begin       // յЭͷ FE
				if(rx_data_valid) begin
					if(rx_data_out == 8'hFE) begin
						state <= ID;
					end else if (rx_data_out == 8'hEF)begin
						state <= STAT2;
					end else begin
						state <= STAT1;
					end
				end
			end
			ID    : begin       // յ
				if(rx_data_valid) begin
					pwm_num <= rx_data_out;
					state <= DATA1;
				end
			end
			DATA1 : begin       // յPWMλ
				if(rx_data_valid) begin
					PWM_width[15:8] <= rx_data_out;
					state <= DATA2;
				end
			end
			DATA2 : begin       // յPWMλ
				if(rx_data_valid) begin
					PWM_width[7:0] <= rx_data_out;
					rx_over <= 1'b1;
					state <= IDLE;
				end
			end
			default :;			
		endcase
	end
end


localparam        PWM01      =     8'd1;
localparam        PWM02      =     8'd2;
localparam        PWM03      =     8'd3;
localparam        PWM04      =     8'd4;
localparam        PWM05      =     8'd5;
localparam        PWM06      =     8'd6;
localparam        PWM07      =     8'd7;
localparam        PWM08      =     8'd8;
localparam        PWM09      =     8'd9;
localparam        PWM10      =     8'd10;
localparam        PWM11      =     8'd11;
localparam        PWM12      =     8'd12;
localparam        PWM13      =     8'd13;
localparam        PWM14      =     8'd14;
localparam        PWM15      =     8'd15;
localparam        PWM16      =     8'd16;
localparam        PWM17      =     8'd17;
localparam        PWM18      =     8'd18;

// PWM01
reg                        PWM_en1 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width1 = 24'b0;             // number of high 
wire                       PWM_busy1;              // PWM is working

// PWM02
reg                        PWM_en2 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width2 = 24'b0;             // number of high 
wire                       PWM_busy2;              // PWM is working

// PWM03
reg                        PWM_en3 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width3 = 24'b0;             // number of high 
wire                       PWM_busy3;              // PWM is working

// PWM04
reg                        PWM_en4 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width4 = 24'b0;             // number of high 
wire                       PWM_busy4;              // PWM is working

// PWM05
reg                        PWM_en5 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width5 = 24'b0;             // number of high 
wire                       PWM_busy5;              // PWM is working

// PWM06
reg                        PWM_en6 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width6 = 24'b0;             // number of high 
wire                       PWM_busy6;              // PWM is working

// PWM07
reg                        PWM_en7 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width7 = 24'b0;             // number of high 
wire                       PWM_busy7;              // PWM is working

// PWM08
reg                        PWM_en8 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width8 = 24'b0;             // number of high 
wire                       PWM_busy8;              // PWM is working

// PWM09
reg                        PWM_en9 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width9 = 24'b0;             // number of high 
wire                       PWM_busy9;              // PWM is working

// PWM10
reg                        PWM_en10 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width10 = 24'b0;             // number of high 
wire                       PWM_busy10;              // PWM is working

// PWM11
reg                        PWM_en11 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width11 = 24'b0;             // number of high 
wire                       PWM_busy11;              // PWM is working

// PWM12
reg                        PWM_en12 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width12 = 24'b0;             // number of high 
wire                       PWM_busy12;              // PWM is working

// PWM13
reg                        PWM_en13 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width13 = 24'b0;             // number of high 
wire                       PWM_busy13;              // PWM is working

// PWM14
reg                        PWM_en14 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width14 = 24'b0;             // number of high 
wire                       PWM_busy14;              // PWM is working

// PWM15
reg                        PWM_en15 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width15 = 24'b0;             // number of high 
wire                       PWM_busy15;              // PWM is working

// PWM16
reg                        PWM_en16 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width16 = 24'b0;             // number of high 
wire                       PWM_busy16;              // PWM is working

// PWM17
reg                        PWM_en17 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width17 = 24'b0;             // number of high 
wire                       PWM_busy17;              // PWM is working

// PWM18
reg                        PWM_en18 = 1'b0;                // enable the PWM module
reg              [23:0]    PWM_width18 = 24'b0;             // number of high 
wire                       PWM_busy18;              // PWM is working


// жһ·PWMҪ
always @ (posedge clk_in) begin
	if(rx_over) begin
		case(pwm_num)
			PWM01 : begin
				if(!PWM_busy1) begin
					PWM_width1 <= PWM_width * 12;
					PWM_en1 <= 1'b1;
				end
				else begin
					PWM_en1 <= 1'b0;
				end
			end
			PWM02 : begin
				if(!PWM_busy2) begin
					PWM_width2 <= PWM_width * 12;
					PWM_en2 <= 1'b1;
				end
				else begin
					PWM_en2 <= 1'b0;
				end
			end
            PWM03 : begin
				if(!PWM_busy3) begin
					PWM_width3 <= PWM_width * 12;
					PWM_en3 <= 1'b1;
				end
				else begin
					PWM_en3 <= 1'b0;
				end
			end
            PWM04 : begin
				if(!PWM_busy4) begin
					PWM_width4 <= PWM_width * 12;
					PWM_en4 <= 1'b1;
				end
				else begin
					PWM_en4 <= 1'b0;
				end
			end
            PWM05 : begin
				if(!PWM_busy5) begin
					PWM_width5 <= PWM_width * 12;
					PWM_en5 <= 1'b1;
				end
				else begin
					PWM_en5 <= 1'b0;
				end
			end
            PWM06 : begin
				if(!PWM_busy6) begin
					PWM_width6 <= PWM_width * 12;
					PWM_en6 <= 1'b1;
				end
				else begin
					PWM_en6 <= 1'b0;
				end
			end
            PWM07 : begin
				if(!PWM_busy7) begin
					PWM_width7 <= PWM_width * 12;
					PWM_en7 <= 1'b1;
				end
				else begin
					PWM_en7 <= 1'b0;
				end
			end
            PWM08 : begin
				if(!PWM_busy8) begin
					PWM_width8 <= PWM_width * 12;
					PWM_en8 <= 1'b1;
				end
				else begin
					PWM_en8 <= 1'b0;
				end
			end
            PWM09 : begin
				if(!PWM_busy9) begin
					PWM_width9 <= PWM_width * 12;
					PWM_en9 <= 1'b1;
				end
				else begin
					PWM_en9 <= 1'b0;
				end
			end
            PWM10 : begin
				if(!PWM_busy10) begin
					PWM_width10 <= PWM_width * 12;
					PWM_en10 <= 1'b1;
				end
				else begin
					PWM_en10 <= 1'b0;
				end
			end
            PWM11 : begin
				if(!PWM_busy11) begin
					PWM_width11 <= PWM_width * 12;
					PWM_en11 <= 1'b1;
				end
				else begin
					PWM_en11 <= 1'b0;
				end
			end
            PWM12 : begin
				if(!PWM_busy12) begin
					PWM_width12 <= PWM_width * 12;
					PWM_en12 <= 1'b1;
				end
				else begin
					PWM_en12 <= 1'b0;
				end
			end
            PWM13 : begin
				if(!PWM_busy13) begin
					PWM_width13 <= PWM_width * 12;
					PWM_en13 <= 1'b1;
				end
				else begin
					PWM_en13 <= 1'b0;
				end
			end
            PWM14 : begin
				if(!PWM_busy14) begin
					PWM_width14 <= PWM_width * 12;
					PWM_en14 <= 1'b1;
				end
				else begin
					PWM_en14 <= 1'b0;
				end
			end
            PWM15 : begin
				if(!PWM_busy15) begin
					PWM_width15 <= PWM_width * 12;
					PWM_en15 <= 1'b1;
				end
				else begin
					PWM_en15 <= 1'b0;
				end
			end
            PWM16 : begin
				if(!PWM_busy16) begin
					PWM_width16 <= PWM_width * 12;
					PWM_en16 <= 1'b1;
				end
				else begin
					PWM_en16 <= 1'b0;
				end
			end
            PWM17 : begin
				if(!PWM_busy17) begin
					PWM_width17 <= PWM_width * 12;
					PWM_en17 <= 1'b1;
				end
				else begin
					PWM_en17 <= 1'b0;
				end
			end
            PWM18 : begin
				if(!PWM_busy18) begin
					PWM_width18 <= PWM_width * 12;
					PWM_en18 <= 1'b1;
				end
				else begin
					PWM_en18 <= 1'b0;
				end
			end
			default :;
		endcase
	end
end


Uart_Bus #
(
.BPS_PARA                   (UART_BAUD) 	// 1250 for 9600 baud rate when 12MHz clk_in
)
uart
(
.clk_in                     (clk_in),				// 12MHz system clock
.rst_n_in                   (rst_n_in),			// system reset, active low

.rs232_rx                   (rs232_rx),			// uart receive pin
.rx_data_valid              (rx_data_valid),		// rx_data_out valid when rx_data_valid active
.rx_data_out                (rx_data_out),		// data of uart receive

.tx_data_valid              (tx_data_valid),		// tx_data_in valid when tx_data_valid active
.tx_data_in                 (tx_data_in),			// data need to transfer
.rs232_tx                   (rs232_tx),			// uart transfer pin
.tx_busy                    (tx_busy)             // uart tx busy
);	


// PWM01
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm1
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en1),                // enable the PWM module
.PWM_width                  (PWM_width1),             // number of high 
.PWM_busy                   (PWM_busy1),              // PWM is working
.PWM_out                    (PWM_out1)
);

// PWM02
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm2
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en2),                // enable the PWM module
.PWM_width                  (PWM_width2),             // number of high 
.PWM_busy                   (PWM_busy2),              // PWM is working
.PWM_out                    (PWM_out2)
);

// PWM03
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm3
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en3),                // enable the PWM module
.PWM_width                  (PWM_width3),             // number of high 
.PWM_busy                   (PWM_busy3),              // PWM is working
.PWM_out                    (PWM_out3)
);

// PWM04
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm4
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en4),                // enable the PWM module
.PWM_width                  (PWM_width4),             // number of high 
.PWM_busy                   (PWM_busy4),              // PWM is working
.PWM_out                    (PWM_out4)
);

// PWM05
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm5
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en5),                // enable the PWM module
.PWM_width                  (PWM_width5),             // number of high 
.PWM_busy                   (PWM_busy5),              // PWM is working
.PWM_out                    (PWM_out5)
);

// PWM06
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm6
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en6),                // enable the PWM module
.PWM_width                  (PWM_width6),             // number of high 
.PWM_busy                   (PWM_busy6),              // PWM is working
.PWM_out                    (PWM_out6)
);

// PWM07
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm7
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en7),                // enable the PWM module
.PWM_width                  (PWM_width7),             // number of high 
.PWM_busy                   (PWM_busy7),              // PWM is working
.PWM_out                    (PWM_out7)
);

// PWM08
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm8
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en8),                // enable the PWM module
.PWM_width                  (PWM_width8),             // number of high 
.PWM_busy                   (PWM_busy8),              // PWM is working
.PWM_out                    (PWM_out8)
);

// PWM09
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm9
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en9),                // enable the PWM module
.PWM_width                  (PWM_width9),             // number of high 
.PWM_busy                   (PWM_busy9),              // PWM is working
.PWM_out                    (PWM_out9)
);

// PWM10
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm10
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en10),                // enable the PWM module
.PWM_width                  (PWM_width10),             // number of high 
.PWM_busy                   (PWM_busy10),              // PWM is working
.PWM_out                    (PWM_out10)
);

// PWM11
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm11
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en11),                // enable the PWM module
.PWM_width                  (PWM_width11),             // number of high 
.PWM_busy                   (PWM_busy11),              // PWM is working
.PWM_out                    (PWM_out11)
);

// PWM12
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm12
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en12),                // enable the PWM module
.PWM_width                  (PWM_width12),             // number of high 
.PWM_busy                   (PWM_busy12),              // PWM is working
.PWM_out                    (PWM_out12)
);

// PWM13
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm13
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en13),                // enable the PWM module
.PWM_width                  (PWM_width13),             // number of high 
.PWM_busy                   (PWM_busy13),              // PWM is working
.PWM_out                    (PWM_out13)
);

// PWM14
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm14
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en14),                // enable the PWM module
.PWM_width                  (PWM_width14),             // number of high 
.PWM_busy                   (PWM_busy14),              // PWM is working
.PWM_out                    (PWM_out14)
);

// PWM15
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm15
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en15),                // enable the PWM module
.PWM_width                  (PWM_width15),             // number of high 
.PWM_busy                   (PWM_busy15),              // PWM is working
.PWM_out                    (PWM_out15)
);

// PWM16
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm16
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en16),                // enable the PWM module
.PWM_width                  (PWM_width16),             // number of high 
.PWM_busy                   (PWM_busy16),              // PWM is working
.PWM_out                    (PWM_out16)
);

// PWM17
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm17
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en17),                // enable the PWM module
.PWM_width                  (PWM_width17),             // number of high 
.PWM_busy                   (PWM_busy17),              // PWM is working
.PWM_out                    (PWM_out17)
);

// PWM18
PWM #
(
.N                          (24),            // length of input data 
.CYCLE                      (240_000)        // 240K * (1 / 12Mhz) = 20ms when 12Mhz clk_in       
)
pwm18
(
.clk_in                     (clk_in),			       // 12MHz system clock
.rst_n_in                   (rst_n_in),		       // system reset, active low

.PWM_en                     (PWM_en18),                // enable the PWM module
.PWM_width                  (PWM_width18),             // number of high 
.PWM_busy                   (PWM_busy18),              // PWM is working
.PWM_out                    (PWM_out18)
);

endmodule