`timescale  1ns / 1ns

module spider_uart_tb;

reg clk,rst_in;
reg   rs232_rx;
wire  rs232_tx;  

reg  [7:0]  num;

reg  [54:0] sgn = 55'b1_0000_0011_01_1_1110_1000_01_1_0000_0001_01_1_1111_1110_01_1_1110_1111_01;

initial begin
    clk = 1'b0;
	num = 8'b0;
    rs232_rx = 1'b1;
    rst_in = 1'b0;  //λ
    #6;            //ʱ6ns
    rst_in = 1'b1;  //ͷ      
end

always #1  clk = ~clk;    //clk 

always #2500 begin
	if(!rst_in) begin
        rs232_rx = 1'b1;
        num = 8'b0;
        end
    else if(num > 8'b0011_0111)
        num <= 8'b0;
    else begin
        rs232_rx <= sgn[num];
        num <= num + 1'b1;
		end
end

wire     [18:1]         PWM_out;
spider #
(
.BPS_PARA              (1250),   // 1250 for 9600 baud rate when 12MHz clk_in

.CHANNEL               (18),       // PWM total 
.N                     (24),
.CYCLE                 (240_000)          
)
spider_test
(
.clk_in                   (clk),				// 12MHz system clock
.rst_n_in                 (rst_in),			// system reset, active low

.rs232_rx                 (rs232_rx),			// uart receive pin
.rs232_tx                 (rs232_tx),			// uart transfer pin

.PWM_out                  (PWM_out)
);

endmodule